from rply import LexerGenerator

from Models.CCLang.TokenDefinition import TokenDefinition


class Lexer:
    def __init__(self):
        self.lexer = LexerGenerator()

    def _add_tokens(self):
        for t in TokenDefinition:
            self.lexer.add(t.name, t.value)

        # Ignore spaces
        self.lexer.ignore('\s+')

    def get_lexer(self):
        self._add_tokens()
        return self.lexer.build()
