from Interpreter.Interpreter import Interpreter
from Interpreter.Utils import Utils
from Interpreter.Repo import Repo


class ServiceInitializer:

    def __init__(self) -> None:
        self.repo = Repo()
        self.utils = Utils(self.repo)
        self.interpreter = Interpreter(self.repo, self.utils)
